﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.IO;
using System.Xml.Serialization;
using Microsoft.Win32;

namespace TileDownLoader.Elevation
{
    public class GpxFiles
    {
        public static gpx GpxFile { get; private set; }

        public static void LoadGpx()
        {
            GpxFile = null;

            OpenFileDialog opfd = new OpenFileDialog();

            opfd.Filter = "GPX Files|*.gpx";
            opfd.Multiselect = false;

            if (opfd.ShowDialog() == true)
            {
                GPXLoader loader = new GPXLoader();

                using (Stream fs = File.OpenRead(opfd.FileName))
                {
                    GpxFile = loader.LoadGPXFile(fs);
                }
            }
        }

        public static void SaveGpx()
        {
            SaveFileDialog sfd = new SaveFileDialog();

            sfd.Filter = "GPX Files|*.gpx";

            if (sfd.ShowDialog() == true)
            {

                using (Stream fs = (Stream)sfd.OpenFile())
                {
                    XmlSerializer ser = new XmlSerializer(typeof(gpx),@"http://www.topografix.com/GPX/1/1");

                    ser.Serialize(fs, GpxFile);

                    fs.Close();
                }
            }
        }

    }
}
